<template>
  <div class="upload-container">
    <el-button :style="{background:color,borderColor:color}" icon="el-icon-upload" size="mini" type="primary" @click="dialogVisible=true">
      文章附件
    </el-button>
    <el-dialog :visible.sync="dialogVisible">
      <el-upload
        ref="upload"
        :multiple="true"
        :action="action"
        :auto-upload="true"
        :show-file-list="false"
        :headers="headers"
        class="editor-slide-upload"
        :before-upload="uploadBefore"
        :on-success="uploadSuccess"
        :on-change="handleChange"
      >
        <el-button size="small" type="primary">
          点击上传
        </el-button>
      </el-upload>
    </el-dialog>
  </div>
</template>

<script>
import { authDB } from '@/db'

export default {
  name: 'EditorSlideUpload',
  props: {
    color: {
      type: String,
      default: '#1890ff'
    }
  },
  data() {
    return {
      dialogVisible: false,
      listObj: {},
      fileList: [],
      headers:{
        'x-token': authDB.get('token'),
        'x-user-id': authDB.get('uid')
      },
    }
  },
  methods: {
    checkAllSuccess() {
      return Object.keys(this.listObj).every(item => this.listObj[item].hasSuccess)
    },
    handleSubmit() {
      const arr = Object.keys(this.listObj).map(v => this.listObj[v])
      this.$emit('successCBK', arr)
      this.listObj = {}
      this.fileList = []
      this.dialogVisible = false
    },
    handleSuccess(response, file) {
      const uid = response.data.filename
      this.listObj[uid] = {
        uid,
        hasSuccess: true,
        width: file.width,
        height: file.height,
        url : "https://oa.hqedust.com/preview/"+ uid
        // url : "http://localhost:8000/api/preview/"+ uid
      }
    },
    handleRemove(file) {
      const uid = file.uid
      const objKeyArr = Object.keys(this.listObj)
      for (let i = 0, len = objKeyArr.length; i < len; i++) {
        if (this.listObj[objKeyArr[i]].uid === uid) {
          delete this.listObj[objKeyArr[i]]
          return
        }
      }
    },
    beforeUpload(file) {
      const _self = this
      const _URL = window.URL || window.webkitURL
      const fileName = file.uid
      return new Promise((resolve, reject) => {
        const img = new Image()
        img.src = _URL.createObjectURL(file)
        resolve(true)
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.editor-slide-upload {
  margin-bottom: 20px;
  ::v-deep .el-upload--picture-card {
    width: 100%;
  }
}
</style>
